<?

/**
 * jsmall 2008-05-19
 * v0.2 updated for PHP 5. This version will not work with implementations using the original FMProxy
 * jsmall 2008-02-10
 * FMProxy class for FileMaker Server. Written for use with FlexFM, but built generically to be compatible with any technology.
 */


/**
 * To Do: 
 * Better error handling
 */


class FMProxyRequest {
	
	/**
    * @var string (The host name without protocol, port, path, etc.)
    * @example some.hostname.com
    */
	public $host="localhost";
	
    /**
    * @var string (http or https)
    */
	public $protocol="http";

	/**
    * @var string
    */
	public $port="80";
	
	/**
    * @var string (valid uri for xml result grammar)
    */
	public $fmiUri="/fmi/xml/fmresultset.xml";
	
	/**
    * @var string 
    */
	public $username="";

	/**
    * @var string 
    */
	public $password="";
	
	/**
    * @var string (The FileMaker CWP command string
    * @example -db=myFile&-lay=myLayout&-findany
    */
	private $commandString="";
	
	/**
    * @var array 
    */
	public $commandArray=array();
	
	/**
    * @var array 
    */
	public $proxyConfigArray=array();
	
	/**
    * @var array 
    */
	public $proxyParamsArray=array();
	
	/**
    * @var string 
    */
	public $result="";
	
	
	/**
    * Constructor
    * @return void
    */
	function __construct(){
		if (@$_POST['Host']!=null){
			$this->host = $_POST['Host'];
		}
		if (@$_POST['Protocol']!=null){
			$this->protocol = $_POST['Protocol'];
		}
		if (@$_POST['Port']!=null){
			$this->port = $_POST['Port'];
		}
		if (@$_POST['FmiUri']!=null){
			$this->fmiUri = $_POST['FmiUri'];
		}
		if (@$_POST['Username']!=null){
			$this->username = $_POST['Username'];
		}
		if (@$_POST['Password']!=null){
			$this->password = $_POST['Password'];
		}
		if (@$_POST['CommandString']!=null){
			$this->commandString = $_POST['CommandString'];
			$this->commandArray = $this->explodeNameValueString($_POST['CommandString']);
		}
		if (@$_POST['ProxyConfig']!=null){
			$this->proxyConfigArray = $this->explodeNameValueString($_POST['ProxyConfig']);
		}
		if (@$_POST['ProxyParams']!=null){
			$this->proxyParamsArray = $this->explodeNameValueString($_POST['ProxyParams']);
		}
	}
    
	
    /**
    * @param string $string Parses parses a generic string of name=value pairs into an associative array
    * @access private
    * @return array
    */
	private function explodeNameValueString($string){
		$_array=explode('&',$string);
		if (count($_array)<2){
			$_nameValue=explode('=',$_array[0],2);
			if (count($_nameValue)<2) {
				$resultArray = array($string);
			}else {
				$resultArray = array($_nameValue[0] => $_nameValue[1]);
			}
		} else {
		foreach ($_array as $_item) {
			$_nameValue=explode('=',$_item,2);
			$_name = $_nameValue[0];
			$_value = @$_nameValue[1];
			$resultArray[$_name]= $_value;
			}
		}
		return $resultArray;
	}
	
	
	/**
    * @access private
    * @return void
    */
	private function repackCommandString(){
		// repack the command array into a command string.
		$amp = "";
		$this->commandString = "";
		foreach ($this->commandArray as $name=>$value){
		    $this->commandString .= $value===null?$amp.$name:$amp.$name.'='.$value;
    		$amp = '&';
		}
	}
	
	
	/**
    * @access public
    * @return void
    */
	public function execute(){
		$this->repackCommandString();
		$this->result = $this->doPost();
	}
	
	
// This function is deprecated. Can't think of a reason to use GET. Just keeping it around for reference.
	/**
    * @access private
    * @return string
    * @abstract pume
    */
	private function doGet() {
		$credentials = empty($this->_username)?'':$this->_username.':'.$this->_password.'@';
		$commandURL = urldecode("http://$credentials$this->_host:$this->_port$this->_fmiUri?$this->_commandString");
		$xml = @file_get_contents($commandURL);
		if (empty($xml)) {
			return "get error: NULL result";
		}
		return $xml;
	}


	/**
    * @access private
    * @return string
    */
	private function doPost () {
		
		$post  = "POST $this->fmiUri HTTP/1.0\r\n";
        $post .= "Host: localhost\r\n";
        $post .= "User-Agent: Soliant-FMProxy\r\n";
        if (!(empty($this->_username) && empty($this->password)) ) {
           $post .= "Authorization: Basic ".base64_encode($this->username.":".$this->password)."\r\n";
        }
        $post .= "Accept: text/xml,text/html,text/plain\r\n";
        $post .= "Content-type: application/x-www-form-urlencoded\r\n";
        $post .= "Content-length: " . strlen($this->commandString) . "\r\n";
        $post .= "\r\n";
        $post .= "$this->commandString";
		
        $response = "";
		$fp = @fsockopen($this->host, $this->port, $errno, $errstr, 30);
        if ($fp === FALSE) {
            return "fsockopen error: " . $errno."/".$errstr;
        }
        $init = fwrite($fp, $post);
        while (!feof($fp)) {
            $response .= fgets($fp, 1024);
        }
        fclose($fp);
        $xml = strstr($response,"<?xml version");
        return $xml;
	}
	
	
	
}
?>
